<%@ attribute name="bazaarvoiceDCCProductData" required="true" type="java.util.HashMap" %>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ tag trimDirectiveWhitespaces="true" %>
<%@taglib prefix="s" uri="http://www.springframework.org/tags" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="ycommerce" uri="http://hybris.com/tld/ycommercetags" %>

<script async type="text/javascript">
    window.bvDCC = {
        catalogData: {
            locale: "${cmsSite.bvLocale}",
            catalogProducts: [
                <c:forEach items="${bazaarvoiceDCCProductData}" var="mapEntry" varStatus="pStatus">
                {
                    <s:eval expression="T(com.bazaarvoice.hybris.utils.BazaarVoiceUtils).ReplaceUnsupportedCharacters(mapEntry.key.code)" var="productCode"/>
                    <s:eval expression="T(com.bazaarvoice.hybris.utils.BazaarVoiceUtils).removeHtml(mapEntry.key.description)" var="productDescription"/>
                    "productId": "${productCode}",
                    "productName": "${mapEntry.key.name}",
                    "productDescription": "${productDescription}",
                    "productImageURL": "${ycommerce:encodeUrl(mapEntry.value.imageUrl)}",
                    "productPageURL": "${ycommerce:encodeUrl(mapEntry.value.productPageUrl)}",
                    "brandName": "${mapEntry.key.manufacturer}",
                    "categoryPath": [
                        <c:forEach items="${mapEntry.key.categories}" var="category" varStatus="cStatus">
                        {
                            "id": "${category.code}",
                            "Name": "${category.name}"
                        }
                        <c:if test="${not cStatus.last}">, </c:if>
                        </c:forEach>
                    ],
                    <c:choose>
                    <c:when test="${mapEntry.value.upc eq null}">
                    "upcs": [],
                    </c:when>
                    <c:otherwise>
                    "upcs": ["${mapEntry.value.upc}"],
                    </c:otherwise>
                    </c:choose>

                    <c:choose>
                    <c:when test="${mapEntry.value.manufacturerAID eq null}">
                    "manufacturerPartNumbers": [],
                    </c:when>
                    <c:otherwise>
                    "manufacturerPartNumbers": ["${mapEntry.value.manufacturerAID}"],
                    </c:otherwise>
                    </c:choose>

                    <c:choose>
                    <c:when test="${mapEntry.value.ean eq null}">
                    "eans": [],
                    </c:when>
                    <c:otherwise>
                    "eans": ["${mapEntry.value.ean}"],
                    </c:otherwise>
                    </c:choose>

                    "family": "${mapEntry.value.familyName}",
                }
                <c:if test="${not pStatus.last}">, </c:if>
                </c:forEach>
            ]
        }
    };

    window.bvCallback = function (BV) {
        // Use a loop for multiple products
        for (var i = 0, len = window.bvDCC.catalogData.catalogProducts.length; i < len; ++i) {
            BV.pixel.trackEvent("CatalogUpdate", {
                type: 'Product',
                locale: window.bvDCC.catalogData.locale,
                catalogProducts: [window.bvDCC.catalogData.catalogProducts[i]]
            });
        }
    };
</script>